//var videoTrackers = [];
var billboard;
var billboardHeight;
var minimumHeight;
var maximumHeight = 600;
var dragBar;
var isDraggableAreaExpanded = false;
var dragThresholdHeight;
var dragTimeout;
var dragTimeLimit = 1500;
var isClick = true;
var animateHeightClassName = "animate-height";
var initialPointerX = 0;
var initialPointerY = 0;

function initEB() {
	if (EB.isInitialized()) {
		startAd();
	}
	else {
		EB.addEventListener(EBG.EventName.EB_INITIALIZED, startAd);
	}
}

function startAd() {
	initializeGlobalVariables();
	//trackVideoInteractions();
	addEventListeners();
	determineIfAutoExpansion();
}

function determineIfAutoExpansion() {
	if (EB._adConfigDefined) {
		var isAutoExpansion = EB._adConfig.customJSVars.mdShouldAutoExpand;

		if (isAutoExpansion) {
			doAutoExpansionBehavior();
		}
	}
}

function doAutoExpansionBehavior() {
	/*var firstVideo = videoTrackers[0];

	if (firstVideo) {
		firstVideo._videoElement.muted = true;
		firstVideo.playVideo(false); // false prevents tracking a user play
		// auto play may be restricted on some phones and tablets
	}*/
}

function initializeGlobalVariables() {
	billboard = document.getElementById("billboard");
	billboardHeight = EB._isLocalMode ? 250 : EB._adConfig.height;
	minimumHeight = billboardHeight;
	dragThresholdHeight = (minimumHeight + maximumHeight) / 2;
	dragBar = document.getElementById("drag-bar");
}

function addEventListeners() {
	var closeButton = document.getElementById("close-button");
	var clickthroughButton = document.getElementById("clickthrough-button");
	//var userActionButton = document.getElementById("user-action-button");

	closeButton.addEventListener("click", collapse);
	clickthroughButton.addEventListener("click", clickthrough);
	//userActionButton.addEventListener("click", userAction);
	dragBar.addEventListener("mousedown", startDrag);
	dragBar.addEventListener("touchstart", startDrag);
	window.addEventListener("message", handleMessageFromCustomScript);

	var cancelAutoCollapseOnUserInteraction = EB._isLocalMode ? false : EB._adConfig.customJSVars.mdCancelAutoCollapseOnUserInteraction;

	if (cancelAutoCollapseOnUserInteraction) {
		document.addEventListener("mousedown", cancelAutoCollapse);
		document.addEventListener("touchstart", cancelAutoCollapse);
	}
}

function handleMessageFromCustomScript(message) {
	try {
		var data = JSON.parse(message.data);

		if (data.type) {
			switch (data.type) {
				case "handleBeforeBillboardCollapse":
					//pauseAllVideos();
					
					if (isDraggableAreaExpanded) {
						collapseDraggableArea();
					}
					break;
				case "handleAfterBillboardExpand":
					// add any code you'd like to run after the billboard expand animation completes
					break;
			}
		}
	}
	catch (error) {}
}

/*function trackVideoInteractions() {
	var videos = document.getElementsByTagName("video");

	for (var i = 0; i < videos.length; i++) {
		videoTrackers.push(new EBG.VideoModule(videos[i]));
	}
}*/

function collapse(event) {
	if (isDraggableAreaExpanded) {
		collapseDraggableArea();
	}
	else {
		collapsePanel();
	}
}

function collapseDraggableArea() {
	billboard.style.height = minimumHeight + "px";	
	billboardHeight = minimumHeight;
	isDraggableAreaExpanded = false;
	dragBar.classList.remove("drag-bar-up");
	dragBar.classList.add("drag-bar-down");
	console.log("collapse");
	
	hideCanvasExp();
	
	
	billboard.addEventListener("transitionend", function(event) {
		var isDraggableAreaCollapsed = billboard.style.height === (minimumHeight + "px");

		if (isDraggableAreaCollapsed) {
			EB._sendMessage("resizeIframe", 
				{
					type: "resizeIframe", 
					height: minimumHeight
				}
			);
		}
	});
}

function collapsePanel() {
	//pauseAllVideos();
	billboard.classList.remove(animateHeightClassName);	

	var leaveBehindPanelName = EB._isLocalMode ? "leavebehind" : EB._adConfig.customJSVars.mdLeaveBehindPanelName;

	EB.expand({
		panelName: leaveBehindPanelName,
		actionType: EBG.ActionType.AUTO
	});

	var billboardPanelName = EB._isLocalMode ? "billboard" : EB._adConfig.customJSVars.mdBillboardPanelName;

	EB.collapse({
		panelName: billboardPanelName
	});
}

/*function pauseAllVideos() {
	var videos = document.getElementsByTagName("video");

	for (var i = 0; i < videos.length; i++) {
		videos[i].pause();
	}
}*/

function clickthrough(event) {
	//pauseAllVideos();
	EB.clickthrough();	
}

/*function userAction(event) {
	EB.userActionCounter("UserAction");
}*/

function startDrag(event) {
	event.preventDefault();
	clearTimeout(dragTimeout);
	expandAdContainer();

	isClick = true;
	initialPointerX = event.clientX || event.changedTouches[0].clientX;
	initialPointerY = event.clientY || event.changedTouches[0].clientY;
	billboard.classList.remove(animateHeightClassName);

	addDragEventListeners();
}

function expandAdContainer() {
	var message = {
		type: "resizeIframe", 
		height: maximumHeight
	};	
	
	EB._sendMessage(message.type, message);
}

function addDragEventListeners() {
	window.addEventListener("mousemove", drag);
	window.addEventListener("mouseup", stopDrag);
	window.addEventListener("touchmove", drag);
	window.addEventListener("touchend", stopDrag);
}

function drag(event) {
	event.preventDefault();
	clearTimeout(dragTimeout);
	dragTimeout = setTimeout(function() {
		stopDrag(event);
	}, dragTimeLimit);

	var pointerY = event.clientY || event.touches[0].clientY;
	var pointerYDistance = pointerY - initialPointerY;
	var newHeight = billboardHeight + pointerYDistance;

	if (isClick) {
		isClick = determineIfIsClick(event);
	}

	billboard.style.height = newHeight + "px";
}

function determineIfIsClick(event) {
	var pointerMoveDistance = getPointerMoveDistance(event);
	var maximumPointerMoveDistance = 5;
	var isMovementDistanceSmallEnough = pointerMoveDistance <= maximumPointerMoveDistance;

	return isMovementDistanceSmallEnough;
}

function getPointerMoveDistance(event) {
	var currentPointerX = event.clientX || event.changedTouches[0].clientX;
	var currentPointerY = event.clientY || event.changedTouches[0].clientY;
	var xDistance = currentPointerX - initialPointerX;
	var yDistance = currentPointerY - initialPointerY;
	var totalDistance = Math.sqrt(Math.pow(xDistance, 2) + Math.pow(yDistance, 2));
	var maximumClickDistance = 5;

	return totalDistance;
}

function stopDrag(event) {
	event.preventDefault();
	clearTimeout(dragTimeout);

	var pointerY = event.clientY || event.changedTouches[0].clientY;
	var isDraggedPastThreshold = pointerY >= dragThresholdHeight;

	removeDragEventListeners();

	billboard.classList.add(animateHeightClassName);

	if (isClick) {
		toggleDragBar();
	}
	else if (isDraggedPastThreshold) {
		expandDraggableArea();
	}
	else {
		collapseDraggableArea();
	}
}

function toggleDragBar() {
	if (isDraggableAreaExpanded) {
		collapseDraggableArea();
		console.log("Collapse");
		
		hideCanvasExp();

	}
	else {
		expandDraggableArea();		
		console.log("Expand");
		
	}
}

function removeDragEventListeners() {
	window.removeEventListener("mousemove", drag);
	window.removeEventListener("mouseup", stopDrag);
	window.removeEventListener("touchmove", drag);
	window.removeEventListener("touchend", stopDrag);
}

function expandDraggableArea() {
	EB.userActionCounter("DragToExpand");

	billboard.style.height = maximumHeight + "px";	
	billboardHeight = maximumHeight;
	dragBar.classList.remove("drag-bar-down");
	dragBar.classList.add("drag-bar-up");
	isDraggableAreaExpanded = true;
	console.log("Expand");	
	showCanvasExp();
	
}

function cancelAutoCollapse(event) {
	document.removeEventListener("mousedown", cancelAutoCollapse);
	document.removeEventListener("touchstart", cancelAutoCollapse);

	EB._sendMessage("cancelAutoCollapse", {});
}

function hideCanvasExp(){
	var tempCanvas = document.getElementById("canvasExp");
	tempCanvas.style.visibility = "hidden";
}

function showCanvasExp(){
	var tempCanvas = document.getElementById("canvasExp");
	tempCanvas.style.visibility = "visible";
	initExp();
}

window.addEventListener("load", initEB);